#!/usr/bin/env python

from BoundedMinimization import *

def f1(k,x,fx,gx,ndimk,ns,jflag,fmax,fnoise):
  fval = sqrt(1+x[0]**2 + (x[1]-x[2])**2)
  nois = 1e-12*fval
  if jflag < 2: return fval,nois
  grd = array([x[0]/fval, (x[1]-x[2])/fval,(x[2]-x[1])/fval])
  gmax = max([abs(grd[0]),grd[1]])
  nois = max([nois,1e-12*gmax])
  return fval,nois,grd

f2 = f1

def test_elfnct(k,x,fx,gx,ndimk,ns,jflag,fmax,fnoise,funcs=()):
  vals = funcs[k-1](k,x,fx,gx,ndimk,ns,jflag,fmax,fnoise)
  fx[0] = vals[0]
  fnoise[0] = vals[1]
  if jflag <2: return
  for j in range(len(x)): gx[j] = vals[2][j]
  return

def test_range(k,mode,w1,w2,ndimk,nsubk,ns):
    nsubk[0] = 2
    if mode == 1:
       w2[0] = w1[0]
       w2[1] = w1[1] - w1[2]
    elif mode == 2:
       w2[0] = w1[0]
       w2[1] = 0.5*w1[1]
       w2[2] = -w1[1]
    elif mode == 3:
       w2[0] = w1[0]
       w2[1] = w1[1]
       w2[2] = -w1[1]
    elif mode == 4:
       w2[0] = w1[0]
       w2[1] = w1[1]
    return

def test_xlower(i):
    return -1e35

def test_xupper(i):
    return -1.0

BM = BoundedMinimization()

BM["elfnct"] = test_elfnct
BM["range"] = test_range
BM["xlower"] = test_xlower
BM["xupper"] = test_xupper

BM["n"] = 4
BM["ns"] = 2

BM["invar"] = [1,2,3,2,3,4]
BM["istate"] = [1,-1,-1,-1,1,1]
BM["nvar"] = [1,4]
BM["x"] = [-3.5,0.1,0.3,-2.3]
BM["funcs"] = (f1,f2)

BM["ipfreq"] = 1
BM["ipwhat"] = 1

#print BM

BM.run()
print BM.x
print BM.fx

