
      SUBROUTINE VE08BD(FNOISE, IFFLAG, IFLAG, INFO, IRTN)
C
C
C       *********************************************************
C       *                                                       *
C       *     CONTROL OF THE ERROR DURING FUNCTION EVALUATION   *
C       *                                                       *
C       *********************************************************
C
C
C
      DOUBLE PRECISION FNOISE
C
C
C   IS FNOISE REALISTIC?
C   --------------------
C
      IRTN = 0
      IF (FNOISE.GE.0.0) GO TO 10
      INFO = IDINT(FNOISE)
      IFLAG = 13
      IRTN = 1
      RETURN
C
C   DOES THE USER WANT TO STOP THE ROUTINE?
C   ---------------------------------------
C
   10 CONTINUE
      IF (IFFLAG.GE.0) RETURN
      INFO = IFFLAG
      IFLAG = 25
      IRTN = 1
      RETURN
      END

      SUBROUTINE VE08CD(I, NDIMI, X, XNEW, INVAR, ISELF)
C
C
C       **************************************************
C       *                                                *
C       *   DETECT IF ELEMENT I IS TO BE RECOMPUTED      *
C       *                                                *
C       **************************************************
C
C
      DOUBLE PRECISION X(1), XNEW(1)
      INTEGER INVAR(1)
C
C   LOOP ON THE VARIABLES OF THE I-TH ELEMENT FUNCTION
C   --------------------------------------------------
C
      DO 10 J=1,NDIMI
        IVAR = INVAR(J)
        IF (X(IVAR).EQ.XNEW(IVAR)) GO TO 10
C
C   THE IVAR-TH VARIABLE HAS BEEN MODIFIED: ASSURE THE I-TH ELEMENT
C   ---------------------------------------------------------------
C       FUNCTION WILL BE RECOMPUTED
C       ---------------------------
C
        IF (ISELF.LE.8) ISELF = ISELF + 10
        RETURN
C
C   END OF THE LOOP ON THE VARIABLES OF THE I-TH ELEMENT
C   ----------------------------------------------------
C
   10 CONTINUE
      RETURN
      END

      SUBROUTINE VE08DD(IELF, NDIMI, NS, P1, P2, P3, GX, DG, X, B,
     * INVAR, ISTATE, ISELF, IPDEVC, IPFREQ, FXI, NGRI, NSUBI, GXOK,
     * TESTGX, HESDIF, RELPR, EPSQRT, DIFGRD, FNOISE, DBIG, GTOL,
     * INFO, IFLAG, IRTN, ELFNCT, RANGE)
C
C
C       *********************************************************
C       *                                                       *
C       *     EVALUATION OF THE IELF-THE ELEMENT FUNCTION,      *
C       *      ITS GRADIENT AND POSSIBLY ITS HESSIAN AT         *
C       *      THE INITIAL POINT X.                             *
C       *                                                       *
C       *********************************************************
C
C
      DOUBLE PRECISION DBIG, DIF, DIFGRD, DIF2, RELPR, EPSQRT, ERR,
     * FNOISE, FXI, FXIP, GTOL, TEMP
      LOGICAL GXOK, TESTGX, HESDIF
      EXTERNAL ELFNCT,RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), P3(1), GX(1), X(1), DG(1), B(1)
      INTEGER INVAR(1), ISTATE(1)
C
C
C   CHECK IF THE I-TH ELEMENT FUNCTION HAS TO BE RECOMPUTED. IF THIS IS
C   --------------------------------------------------------------------
C       THE CASE, BRANCH TO POSSIBLE HESSIAN ESTIMATION
C       -----------------------------------------------
C
      IRTN = 0
      IUTMB = 4
      IUMB = 2
      NGRI = 0
      IF (ISELF.GE.8) GO TO 10
      GO TO 90
C
C   THE I-TH ELEMENT FUNCTION HAS TO BE RECOMPUTED
C   ----------------------------------------------
C
   10 CONTINUE
      ISELF = ISELF - 10
      IFFLAG = 2
      IF (ISELF.LT.0) IFFLAG = 1
C
C   PREPARE THE DATA POINT FOR THE I-TH ELEMENT FUNCTION IN P1
C   ----------------------------------------------------------
C
      DO 20 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = X(INVARI)
   20 CONTINUE
C
C   EVALUATE THE I-TH ELEMENT FUNCTION
C   ----------------------------------
C
      CALL ELFNCT(IELF, P1, FXI, GX, NDIMI, NS, IFFLAG, DBIG, FNOISE)
      NGRI = NGRI + 1
      CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
      IF (JRTN.EQ.1) GO TO 140
C
C   ESTIMATION OF THE GRADIENT BY DIFFERENCE
C   ----------------------------------------
C
C   1) IS ESTIMATION NEEDED?
C
      IF (ISELF.GE.0 .AND. (.NOT.TESTGX)) GO TO 90
C
C   2) YES: LOOP ON THE SUBDIMENSIONS TO PREPARE THE PERTURBED DATA
C       POINT
C
      JJ = 1
      DO 80 J=1,NDIMI
        INVARJ = INVAR(J)
        IF (ISTATE(INVARJ).EQ.0) GO TO 70
        TEMP = P1(J)
        IF (DABS(TEMP).GT.RELPR) GO TO 30
        P1(J) = TEMP + EPSQRT
        GO TO 40
   30   CONTINUE
        P1(J) = TEMP*(1.0+DIFGRD)
   40   CONTINUE
        DIF = P1(J) - TEMP
C
C   3) RE-EVALUATE THE I-TH ELEMENT FUNCTION AT PERTURBED POINT
C
        CALL ELFNCT(IELF, P1, FXIP, P2, NDIMI, NS, IFFLAG, DBIG, FNOISE)
        NGRI = NGRI + 1
        CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
        IF (JRTN.EQ.1) GO TO 140
C
C   4) ESTIMATE THE J-TH COMPONENT OF THE GRADIENT AND TEST IT W.R.T. IT
C       ANALYTICAL VALUE IF NEEDED
C
        TEMP = (FXIP-FXI)/DIF
        IF (ISELF.GE.0) GO TO 50
        GX(JJ) = TEMP
        GO TO 60
   50   CONTINUE
        ERR = DABS(GX(JJ)-TEMP)/(1.0+DABS(TEMP))
        IF (ERR.LE.GTOL) GO TO 60
        IF (IPFREQ.GE.0) WRITE (IPDEVC,99999) J, IELF, GX(JJ), TEMP
        GXOK = .FALSE.
   60   CONTINUE
C
C   5) RESET DATA POINT
C
        P1(J) = P1(J) - DIF
C
C   6) END OF THE LOOP ON THE SUBDIMENSIONS
C
   70   CONTINUE
        JJ = JJ + 1
   80 CONTINUE
C
C   ESTIMATE THE INITIAL I-TH ELEMENT HESSIAN BY DIFFERENCES
C   --------------------------------------------------------
C
C   1) GET THE SUBDIMENSION AND PROJECT THE ELEMENT GRADIENT ON THE
C       RANGE
C
   90 CONTINUE
      IF (.NOT.HESDIF) RETURN
      CALL RANGE(IELF, IUTMB, GX, P3, NDIMI, NSUBI, NS)
      IF (NSUBI.EQ.0 .OR. ISELF.LT.0) RETURN
      L = 0
      DIF2 = DIFGRD + DIFGRD
C
C   2) LOOP ON THE SUBDIMENSION
C
      NSUBIT = NSUBI
      DO 130 J=1,NSUBI
C
C   3) BUILD THE PERTURBED DATA POINT
C
        DO 100 K=1,NSUBI
          P1(K) = 0.0
  100   CONTINUE
        P1(J) = 1.0
        CALL RANGE(IELF, IUMB, P1, P2, NDIMI, NSUBIT, NS)
        TEMP = DIF2
        DO 110 K=1,NDIMI
          INVARK = INVAR(K)
          DG(K) = TEMP*P2(K) + X(INVARK)
  110   CONTINUE
C
C   4) COMPUTE THE NEW PERTURBED GRADIENT, PROJECTED ON THE RANGE
C
        IFFLAG = 2
        CALL ELFNCT(IELF, DG, TEMP, P1, NDIMI, NS, IFFLAG, DBIG, FNOISE)
        NGRI = NGRI + 1
        CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
        IF (JRTN.EQ.1) GO TO 140
C
C   5) COMPUTE THE J-TH ROW OF THE I-TH ELEMENT HESSIAN
C
        CALL RANGE(IELF, IUTMB, P1, P2, NDIMI, NSUBIT, NS)
        DO 120 K=1,J
          L = L + 1
          B(L) = (P2(K)-P3(K))/DIF2
  120   CONTINUE
C
C   6) END OF THE LOOP ON THE SUBDIMENSION
C
  130 CONTINUE
      RETURN
C
C   ERROR EXIT
C   ----------
C
  140 IRTN = 1
      RETURN
99999 FORMAT (5X, 36HPOSSIBLE ERROR IN THE COMPUTATION OF, 9H THE ANAL,
     * 16HYTICAL GRADIENT /5X, 4HTHE , I3, 21H-TH COMPONENT OF THE ,
     * I5, 24H-TH ELEMENT GRADIENT HAS/5X, 22HA COMPUTED VALUE OF   ,
     * D14.7, 4H AND/5X, 22HAN ESTIMATED VALUE OF , D14.7, 1H./)
      END

      SUBROUTINE VE08ED(IELF, NDIMI, NS, P1, P2, B, ISELF, NSUBI,
     * HESDIF, RANGE)
C
C
C       ************************************************
C       *                                              *
C       *   INITIALIZES THE IELF-TH ELEMENT HESSIAN    *
C       *      TO THE IDENTITY MATRIX                  *
C       *                                              *
C       ************************************************
C
C
      LOGICAL HESDIF
      EXTERNAL RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), B(1)
C
C
C   GET THE TRUE SUBDIMENSION NSUBI
C   -------------------------------
C
      L = 1
      IUB = 1
      CALL RANGE(IELF, IUB, P1, P2, NDIMI, NSUBI, NS)
C
C   INITIALIZE THE I-TH ELEMENT HESSIAN
C   -----------------------------------
C
      IF (NSUBI.EQ.0 .OR. (HESDIF .AND. ISELF.GT.0)) RETURN
      B(1) = 1.0
      IF (NSUBI.LE.1) RETURN
      DO 20 J=2,NSUBI
        JJ = J - 1
        DO 10 K=1,JJ
          L = L + 1
          B(L) = 0.0
   10   CONTINUE
        L = L + 1
        B(L) = 1.0
   20 CONTINUE
      RETURN
      END

      SUBROUTINE VE08FD(IELF, NDIMI, INVAR, GX, GI, ISTATE)
C
C
C       **************************************************
C       *                                                *
C       *  THIS ROUTINE ACCUMULATES THE OVERAL GRADIENT  *
C       *    FROM THE IELF-TH ELEMENT GRADIENT           *
C       *                                                *
C       **************************************************
C
C
C
C
      DOUBLE PRECISION GX(1), GI(1)
      INTEGER INVAR(1), ISTATE(1)
C
C
      DO 10 I=1,NDIMI
        IVAR = INVAR(I)
        IF (ISTATE(IVAR).NE.0) GX(IVAR) = GX(IVAR) + GI(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE VE08GD(IELF, NDIMI, NS, P1, P2, P3, DG, B, INVAR,
     * NSUBI, RESTRT, HESDIF, RANGE)
C
C
C       ************************************************************
C       *                                                          *
C       *   ASSEMBLY OF THE DIAGONAL OF THE FIRST ELEMENT HESSIAN  *
C       *           APPROXIMATIONS                                 *
C       *                                                          *
C       ************************************************************
C
C
      LOGICAL RESTRT, HESDIF
      EXTERNAL RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), P3(1), DG(1), B(1)
      INTEGER INVAR(1)
C
C
C
C   LOOP ON THE SUBDIMENSION
C   ------------------------
C
      IUB = 1
      IUTB = 3
      DO 40 J=1,NDIMI
C
C   PREPARE THE J-TH SUB-BASIS VECTOR
C   ---------------------------------
C
        DO 10 K=1,NDIMI
          P1(K) = 0.0
   10   CONTINUE
        P1(J) = 1.0
C
C   PROJECT ON THE RANGE
C   --------------------
C
        CALL RANGE(IELF, IUB, P1, P2, NDIMI, NSUBI, NS)
        IF (NSUBI.EQ.0) RETURN
C
C   WHEN RESTARTING, COMPUTE THE PRODUCT WITH THE STARTING APPROXIMATION
C   --------------------------------------------------------------------
C       TO THE ELEMENT HESSIANS:
C       ------------------------
C
        IF (.NOT.(RESTRT .OR. HESDIF)) GO TO 30
        CALL VE08PD(B, P2, P3, NSUBI)
        DO 20 K=1,NSUBI
          P2(K) = P3(K)
   20   CONTINUE
C
C   RESTORE TO FULL SUBDIMENSION
C   ----------------------------
C
   30   CONTINUE
        CALL RANGE(IELF, IUTB, P2, P1, NDIMI, NSUBI, NS)
C
C   ACCUMULATE IN THE CORRESPONDING DIAGONAL ELEMENT
C   ------------------------------------------------
C
        IVAR = INVAR(J)
        DG(IVAR) = DG(IVAR) + P1(J)
   40 CONTINUE
      RETURN
      END

      SUBROUTINE VE08HD(IELF, NDIMI, NS, P1, P2, P3, X, GXI, INVAR,
     * ISTATE, ISELF, FXI, NGRI, DIFGRD, FNOISE, DBIG, FMAX, INFO,
     * IFLAG, IRTN, ELFNCT, RANGE)
C
C
C       *************************************************************
C       *                                                           *
C       *   RECOMPUTATION OF THE IELF-TH ELEMENT FUNCTION AND       *
C       *      GRADIENT AFTER MODIFICATION OF THE LINEAR VARIABLES  *
C       *                                                           *
C       *************************************************************
C
C
      DOUBLE PRECISION DBIG, DERJ, DIFGRD, FMAX, FNOISE, FXFWD, FXI
      EXTERNAL ELFNCT, RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), P3(1), X(1), GXI(1)
      INTEGER INVAR(1), ISTATE(1)
C
C
      IRTN = 0
      IUB = 1
      IUTB = 3
      IUMB = 2
      NGRI = 0
C
C   CHECK IF THE I-TH ELEMENT FUNCTION HAS TO BE RECOMPUTED.
C   --------------------------------------------------------
C
      IF (ISELF.LT.8) RETURN
C
C   THE I-TH ELEMENT FUNCTION HAS TO BE RECOMPUTED
C   ----------------------------------------------
C
      ISELF = ISELF - 10
C
C   PREPARE THE DATA POINT FOR THE I-TH ELEMENT FUNCTION IN P1
C   ----------------------------------------------------------
C
      DO 10 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = X(INVARI)
   10 CONTINUE
C
C   EVALUATE THE I-TH ELEMENT FUNCTION
C   ----------------------------------
C
      IFFLAG = 2
      IF (ISELF.LT.0) IFFLAG = 1
      CALL ELFNCT(IELF, P1, FXI, GXI, NDIMI, NS, IFFLAG, FMAX, FNOISE)
      NGRI = NGRI + 1
      CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
      IF (JRTN.EQ.1) GO TO 60
C
C   ESTIMATE THE ELEMENT GRADIENT BY DIFFERENCES
C   --------------------------------------------
C
C   1) CHECK IF ESTIMATION IS NEEDED
C
      IF (ISELF.GT.0) RETURN
C
C   2) GET THE TRUE SUBDIMENSION
C
      CALL RANGE(IELF, IUB, GXI, P3, NDIMI, NSUBI, NS)
      IF (NSUBI.EQ.0) RETURN
C
C   3) LOOP ON THE SUBDIMENSION
C
      NSUBIT = NSUBI
      DO 40 J=1,NSUBI
        INVARJ = INVAR(J)
        IF (NSUBI.EQ.NDIMI .AND. ISTATE(INVARJ).EQ.0) GO TO 40
C
C   4) SET DATA POINT
C
        DO 20 K=1,NSUBI
          P2(K) = 0.0
   20   CONTINUE
        P2(J) = 1.0
        CALL RANGE(IELF, IUTB, P2, P1, NDIMI, NSUBIT, NS)
        DO 30 K=1,NDIMI
          INVARK = INVAR(K)
          P2(K) = P1(K)*DIFGRD + X(INVARK)
   30   CONTINUE
C
C   5) COMPUTE FUNCTION VALUE AT PERTURBED DATA POINT
C
        CALL ELFNCT(IELF, P2, FXFWD, P1, NDIMI, NS, IFFLAG, DBIG,
     *   FNOISE)
        NGRI = NGRI + 1
        CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
        IF (JRTN.EQ.1) GO TO 60
C
C   6) ESTIMATE THE J-TH COMPONENT OF THE ELEMENT GRADIENT IN
C       SUBDIMENSION
C
        DERJ = (FXFWD-FXI)/DIFGRD
        P3(J) = DERJ - P3(J)
   40 CONTINUE
C
C   7) RESTORE THE ELEMENT GRADIENT TO FULL SUBDIMENSION
C
      CALL RANGE(IELF, IUMB, P3, P2, NDIMI, NSUBI, NS)
      DO 50 J=1,NDIMI
        GXI(J) = GXI(J) + P2(J)
        INVARJ = INVAR(J)
        IF (ISTATE(INVARJ).EQ.0) GXI(J) = 0.0
   50 CONTINUE
      RETURN
   60 CONTINUE
      IRTN = 1
      RETURN
      END

      SUBROUTINE VE08ID(IELF, NDIMI, NS, P1, P2, W1, W2, B, INVAR,
     * ISTATE, NSUBI, RANGE)
C
C
C       **********************************************************
C       *                                                        *
C       *    COMPUTATION OF THE PRODUCT OF THE IELF-TH ELEMENT   *
C       *     HESSIAN WITH W1 INTO W2.                           *
C       *                                                        *
C       **********************************************************
C
C
C
C
      DOUBLE PRECISION W1(1), W2(1), B(1), P1(1), P2(1)
      INTEGER INVAR(1), ISTATE(1)
      EXTERNAL RANGE
C
C
      IUB = 1
      IUTB = 3
C
C   BUILD THE CORRESPONDING DIRECTION VECTOR IN SUBDIMENSION
C   --------------------------------------------------------
C
      DO 10 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = W1(INVARI)
   10 CONTINUE
C
C   PROJECT ON THE RANGE OF THE I-TH ELEMENT HESSIAN
C   ------------------------------------------------
C
      CALL RANGE(IELF, IUB, P1, P2, NDIMI, NSUBI, NS)
      IF (NSUBI.EQ.0) RETURN
C
C   CHECK IF PRODUCT IS NEEDED
C   --------------------------
C
      DO 20 J=1,NSUBI
        IF (P2(J).NE.0.0) GO TO 30
   20 CONTINUE
      RETURN
C
C   COMPUTE THE PRODUCT ON THE RANGE
C   --------------------------------
C
   30 CONTINUE
      CALL VE08PD(B, P2, P1, NSUBI)
C
C   RESTORE PRODUCT TO FULL SUBDIMENSION
C   ------------------------------------
C
      CALL RANGE(IELF, IUTB, P1, P2, NDIMI, NSUBI, NS)
C
C   ACCUMULATE THE EXPANDED PRODUCT IN THE VECTOR W2
C   ------------------------------------------------
C
      DO 40 J=1,NDIMI
        IVAR = INVAR(J)
        IF (ISTATE(IVAR).NE.0) W2(IVAR) = W2(IVAR) + P2(J)
   40 CONTINUE
      RETURN
      END

      SUBROUTINE VE08JD(IELF, NDIMI, NS, P1, X, XOLD, GI1, GI2, INVAR,
     * ISTATE, ISELF, NGRI, DIFEST, GSINI, A, FNOISE, FMAX, FXI, GSA,
     * IKLS, MAXLS, INFO, IFLAG, IRTN, ELFNCT)
C
C
C       *****************************************************
C       *                                                   *
C       *   COMPUTATION OF THE VALUE OF THE IELF-TH ELEMENT *
C       *     FUNCTION AT THE POINT X, AND OF ITS GRADIENT, *
C       *     IF ANALYTICAL GRADIENTS ARE AVAILABLE.        *
C       *                                                   *
C       *****************************************************
C
C
      DOUBLE PRECISION A, FMAX, FNOISE, FXI, GSA, GSINI, TEMP
      LOGICAL DIFEST
      EXTERNAL ELFNCT
C
C
      DOUBLE PRECISION P1(1), GI1(1), GI2(1), X(1), XOLD(1)
      INTEGER INVAR(1), ISTATE(1)
C
C
      IRTN = 0
      NGRI = 0
      IF (ISELF.GE.8) GO TO 20
      DO 10 I=1,NDIMI
        GI1(I) = GI2(I)
   10 CONTINUE
      GO TO 40
C
C   PREPARE THE DATA POINT
C   ----------------------
C
   20 CONTINUE
      ITEMP = ISELF - 10
      IF (.NOT.DIFEST) ISELF = ITEMP
      IFFLAG = 2
      IF (ITEMP.LT.0) IFFLAG = 1
      DO 30 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = X(INVARI)
   30 CONTINUE
C
C   COMPUTE THE NEW VALUE OF THE I-TH ELEMENT FUNCTION
C   --------------------------------------------------
C
      CALL ELFNCT(IELF, P1, FXI, GI1, NDIMI, NS, IFFLAG, FMAX, FNOISE)
      NGRI = NGRI + 1
      CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
      IF (JRTN.EQ.1) GO TO 60
C
C   TEST IF OVERSHOOT IS DETECTED BY THE USER. IN THIS CASE, STOP
C   -------------------------------------------------------------
C       EVALUATION AND BRANCH TO HALVE THE STEP
C       ---------------------------------------
C
      IF (IFFLAG.EQ.0 .AND. IKLS.LT.MAXLS) IRTN = 2
      IF (IFFLAG.EQ.0 .AND. IKLS.LT.MAXLS) RETURN
C
C   ACCUMULATE THE NEW DIRECTIONAL DERIVATIVE
C   -----------------------------------------
C
   40 CONTINUE
      IF (DIFEST) RETURN
      DO 50 J=1,NDIMI
        IVAR = INVAR(J)
        ISVAR = ISTATE(IVAR)
        IF (ISVAR.EQ.0) GO TO 50
        TEMP = X(IVAR)-XOLD(IVAR)
        GSA = GSA + TEMP*GI1(J)/A
        IF (ISVAR.LT.0 .OR. ISVAR.GT.2) GO TO 50
        GSINI = GSINI + TEMP*GI2(J)
   50 CONTINUE
      RETURN
   60 CONTINUE
      IRTN = 1
      RETURN
      END

      SUBROUTINE VE08KD(IELF, NDIMI, NS, P1, P2, P3, G1, G2, X, XOLD,
     * B, ISELF, INVAR, ISTATE, NSUBI, NGRI, FXI, FNOISE, XNOISE,
     * EPSQRT, RELPR, TOLCNT, A, DXN1, GSA, GSINI, GXMAX, INFO,
     * IFLAG, IRTN, ELFNCT, RANGE)
C
C
C       *************************************************************
C       *                                                           *
C       *    COMPUTATION OF ONE ELEMENT GRADIENT BY DIFFERENCES,    *
C       *        USING STEWART'S ALGORITHM.                         *
C       *                                                           *
C       *************************************************************
C
C
C
      DOUBLE PRECISION A, ALPHA, DALPHA, DBIG, DDENOM, DELTA, DERJ,
     * DGAMMA, DISCR, DNUM, DPHI, DXN1, RELPR, EPSQRT, ETA,
     * FNOISE, FXBWD, FXFWD, FXI, GAMMA, GAM2, GSA, GSINI, GXMAX,
     * TEMP, TEST, TOLCNT, XI, XNOISE
      EXTERNAL ELFNCT, RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), P3(1), G1(1), G2(1), X(1),
     * XOLD(1), B(1)
      INTEGER ISTATE(1), INVAR(1)
C
C
      IRTN = 0
      IUB = 1
      IUTB = 3
      IUMB = 2
      NGRI = 0
C
C   PROJECT THE ELEMENT GRADIENT ON THE RANGE
C   -----------------------------------------
C
      CALL RANGE(IELF, IUB, G2, G1, NDIMI, NSUBI, NS)
C
C   IF THE GRADIENT IS KNOWN ALREADY, COPY ITS VALUE
C   ------------------------------------------------
C
      IF (ISELF.GE.8) GO TO 20
      DO 10 I=1,NDIMI
        G1(I) = G2(I)
   10 CONTINUE
      GO TO 210
   20 CONTINUE
      ISELF = ISELF - 10
      IF (ISELF.GE.0) RETURN
      IF (NSUBI.EQ.0) GO TO 190
C
C   PREPARE THE DATA POINT
C   ----------------------
C
      IFFLAG = 1
      DO 30 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = X(INVARI)
   30 CONTINUE
C
C   SET THE PARAMETERS FOR STEWART'S ALGORITHM
C   ------------------------------------------
C
      DPHI = DMAX1(DABS(FXI),FNOISE,RELPR)
      XI = 0.0
      DO 40 I=1,NDIMI
        XI = XI + P1(I)**2
   40 CONTINUE
      XI = DSQRT(XI)
C
C   LOOP ON THE TRUE SUBDIMENSION
C   -----------------------------
C
      LL = 0
      NSUBIT = NSUBI
      DO 150 J=1,NSUBI
        LL = LL + J
        INVARJ = INVAR(J)
        IF (NSUBI.EQ.NDIMI .AND. ISTATE(INVARJ).EQ.0) GO TO 150
        ALPHA = B(LL)
        DALPHA = DABS(ALPHA)
        IF (DALPHA.GE.EPSQRT) GO TO 50
        DELTA = EPSQRT
        TEST = 1.0
        GO TO 90
   50   CONTINUE
        GAMMA = G1(J)
        DGAMMA = DABS(GAMMA)
C
C   COMPUTE ETA, THE ACCURACY FACTOR
C   --------------------------------
C
        ETA = DMAX1(FNOISE,(DGAMMA*XI*XNOISE)/DPHI)
C
C   TEST IF CENTRAL DIFFERENCE IS NEEDED BECAUSE OF CANCELLATION ERRORS
C   -------------------------------------------------------------------
C        IN THE COMPUTATION OF THE OVERAL GRADIENT
C         ----------------------------------------
C
        IF (GXMAX.LE.100.0*EPSQRT*DGAMMA) GO TO 80
C
C   COMPUTE THE VALUE OF ACCURACY CONDITION
C   ---------------------------------------
C
        TEST = DALPHA*DPHI*ETA
        GAM2 = GAMMA**2
        IF (GAM2.LE.TEST .AND. DGAMMA.GE.(100.*EPSQRT)) GO TO 60
C
C   FIRST ALTERNATIVE
C   -----------------
C
        DELTA = 2.0*DSQRT(ETA*DPHI/DALPHA)
        DNUM = DALPHA*DELTA
        GO TO 70
C
C   SECOND ALTERNATIVE
C   ------------------
C
   60   CONTINUE
        DELTA = 2.0*(ETA*DPHI*DGAMMA/ALPHA**2)**(1.0/3.0)
        DNUM = GAMMA + GAMMA
C
C   NEWTON'S REFINEMENT
C   -------------------
C
   70   CONTINUE
        DDENOM = 3.0*DALPHA*DELTA + 4.0*DGAMMA
        IF (DABS(DDENOM).GT.RELPR) DELTA = DELTA*(1.0-DNUM/DDENOM)
        DELTA = DSIGN(DELTA,GAMMA)
        DELTA = DSIGN(DELTA,ALPHA)
C
C   TEST IF CENTRAL DIFFERENCE ARE NEEDED. IF YES, COMPUTE THE NEW DELTA
C   --------------------------------------------------------------------
C
        TEST = 1.0
        IF (DABS(ALPHA*DELTA).LT.TOLCNT*DGAMMA .AND. DELTA.LE.A*DXN1)
     *   GO TO 90
   80   CONTINUE
        DISCR = GAM2 + 4.0*DALPHA*DPHI*ETA/TOLCNT
        DELTA = -DGAMMA/DALPHA + DSQRT(DISCR)/DALPHA
        TEST = -1.0
   90   CONTINUE
        TEMP = DMAX1(DABS(DELTA),0.001*EPSQRT)
        DELTA = DSIGN(TEMP,DELTA)
C
C   FORWARD DIFFERENCE: COMPUTE THE PERTURBED POINT
C   -----------------------------------------------
C
        DO 100 K=1,NSUBI
          P2(K) = 0.0
  100   CONTINUE
        P2(J) = 1.0
        CALL RANGE(IELF, IUTB, P2, P1, NDIMI, NSUBIT, NS)
        DO 110 K=1,NDIMI
          P2(K) = P1(K)*DELTA
          INVARK = INVAR(K)
          P1(K) = X(INVARK) + P2(K)
  110   CONTINUE
C
C   FORWARD DIFFERENCE: COMPUTE THE PERTURBED VALUE OF THE ELEMENT
C   --------------------------------------------------------------
C       FUNCTION
C       --------
C
        CALL ELFNCT(IELF, P1, FXFWD, P3, NDIMI, NS, IFFLAG, DBIG,
     *   FNOISE)
        NGRI = NGRI + 1
        CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
        IF (JRTN.EQ.1) GO TO 230
C
C   BACKWARD DIFFERENCE: COMPUTE THE SECOND PERTURBED DATA POINT
C   ------------------------------------------------------------
C
        IF (TEST.GT.0.0) GO TO 130
        DO 120 K=1,NDIMI
          INVARK = INVAR(K)
          P1(K) = X(INVARK) - P2(K)
  120   CONTINUE
C
C   BACKWARD DIFFERENCE: COMPUTE THE ELEMENT FUNCTION VALUE AT SECOND
C   -----------------------------------------------------------------
C       PERTURBED DATA POINT
C       --------------------
C
        CALL ELFNCT(IELF, P1, FXBWD, P3, NDIMI, NS, IFFLAG, DBIG,
     *   FNOISE)
        NGRI = NGRI + 1
        CALL VE08BD(FNOISE, IFFLAG, IFLAG, INFO, JRTN)
        IF (JRTN.EQ.1) GO TO 230
C
C   CENTRAL DIFFERENCE: ESTIMATE THE J-TH COMPONENT OF GRADIENT IN
C   --------------------------------------------------------------
C       SUBDIMENSION
C       ------------
C
        DERJ = (FXFWD-FXBWD)/(DELTA+DELTA)
        GO TO 140
C
C   FORWARD DIFFERENCE: ESTIMATE THE J-TH COMPONENT OF GRADIENT IN
C   --------------------------------------------------------------
C       SUBDIMENSION
C       ------------
C
  130   CONTINUE
        DERJ = (FXFWD-FXI)/DELTA
C
C   MODIFY THE J-TH COMPONENT OF THE PROJECTED GRADIENT
C   ---------------------------------------------------
C
  140   CONTINUE
        G1(J) = DERJ - G1(J)
C
C   END OF THE LOOP ON THE SUBDIMENSIONS
C   ------------------------------------
C
  150 CONTINUE
C
C   RESTORE THE ELEMENT GRADIENT TO THE FULL SUBDIMENSION
C   -----------------------------------------------------
C
      IF (NDIMI.EQ.NSUBI) GO TO 170
      DO 160 I=1,NSUBI
        P1(I) = G1(I)
  160 CONTINUE
      CALL RANGE(IELF, IUMB, P1, G1, NDIMI, NSUBI, NS)
  170 CONTINUE
      DO 180 J=1,NDIMI
        G1(J) = G2(J) + G1(J)
        INVARJ = INVAR(J)
        IF (ISTATE(INVARJ).EQ.0) G1(J) = 0.0
  180 CONTINUE
      GO TO 210
  190 CONTINUE
      DO 200 I=1,NDIMI
        G1(I) = G2(I)
  200 CONTINUE
C
C   ACCUMULATE THE DIRECTIONAL DERIVATIVE
C   -------------------------------------
C
  210 CONTINUE
      DO 220 J=1,NDIMI
        IVAR = INVAR(J)
        ISVAR = ISTATE(IVAR)
        IF (ISVAR.EQ.0) GO TO 220
        TEMP = X(IVAR)-XOLD(IVAR)
        GSA = GSA + TEMP*G1(J)/A
        IF (ISVAR.LT.0 .OR. ISVAR.GT.2) GO TO 220
        GSINI = GSINI + TEMP*G2(J)
  220 CONTINUE
      RETURN
  230 CONTINUE
      IRTN = 1
      RETURN
      END

      SUBROUTINE VE08LD(IELF, NDIMI, NS, P1, P2, P3, Y, S, D, B, RESN2,
     * ISELF, INVAR, KU, PRERED, SCAL1, RELPR, GNOISE, INFO, IFLAG,
     * IRTN, RANGE)
C
C
C
C       ****************************************************
C       *                                                  *
C       *     UPDATING OF THE IELF-TH ELEMENT HESSIAN      *
C       *                                                  *
C       ****************************************************
C
C
C
      DOUBLE PRECISION DSBSI, DYSI, RELPR, GNOISE, PRERED, Q, RESN2,
     * RNI1, RNI2, RSI, RSII, SBSI, SNI2, TEMP, YSI
      LOGICAL SCAL1
      EXTERNAL RANGE
C
C
      DOUBLE PRECISION P1(1), P2(1), P3(1), Y(1), S(1), D(1), B(1)
      INTEGER INVAR(1)
C
C
C
      IRTN = 0
      PRERED = 0.0
      IUTB = 3
      IUTMB = 4
      IUB = 1
C
C   BUILD THE PRODUCT OF THE DIFFERENCE IN GRADIENTS TIMES THE STEP(YSI)
C   --------------------------------------------------------------------
C
C   1) BUILD THE UNPROJECTED DIFFERENCE IN P1
C
      DO 10 I=1,NDIMI
        P1(I) = Y(I)
   10 CONTINUE
C
C   2) PROJECT IT ON THE RANGE
C
      CALL RANGE(IELF, IUTMB, P1, P2, NDIMI, NSUBI, NS)
      KU = (NSUBI*(NSUBI+1))/2
      IF (NSUBI.EQ.0) RETURN
      IF (NSUBI.EQ.NDIMI) GO TO 30
C
C   3) STORE THE RESULT IN Y
C
      DO 20 I=1,NSUBI
        Y(I) = P2(I)
   20 CONTINUE
C
C   4) BUILD THE UNPROJECTED STEP IN P1
C
   30 CONTINUE
      DO 40 I=1,NDIMI
        INVARI = INVAR(I)
        P1(I) = S(INVARI)
   40 CONTINUE
C
C   5) PROJECT THE STEP ON THE RANGE
C
      CALL RANGE(IELF, IUB, P1, P2, NDIMI, NSUBI, NS)
C
C   6) COMPUTE YSI
C
      YSI = 0.0
      DO 50 J=1,NSUBI
        YSI = YSI + P2(J)*Y(J)
   50 CONTINUE
C
C   COMPUTE THE PRODUCT OF THE PROJECTED STEP TIMES THE ELEMENT HESSIAN
C   -------------------------------------------------------------------
C
C
C   1) COMPUTE THE PRODUCT ON THE RANGE
C
      CALL VE08PD(B, P2, P1, NSUBI)
C
C   2) COMPUTE THE PRODUCT OF THE RESULT WITH THE PROJECTED STEP (SBSI)
C       AND THE SQUARE OF THE NORM OF THE PROJECTED STEP
C
      SBSI = 0.0
      SNI2 = 0.0
      RNI2 = 0.0
      DO 60 J=1,NSUBI
        SNI2 = SNI2 + P2(J)**2
        SBSI = SBSI + P1(J)*P2(J)
C
C   3) UPDATE THE SQUARE OF THE RESIDUAL NORM
C
        RNI2 = RNI2 + (Y(J)-P1(J))**2
   60 CONTINUE
      RESN2 = RESN2 + RNI2
C
C   4) UPDATE THE VALUE OF THE PREDICTED REDUCTION IN THE
C       OBJECTIVE FUNCTION
C
      PRERED = YSI - 0.5*SBSI
C
C   CHECK IF THE NOISE ON THE DIFFERENCE IN GRADIENT IS BELOW THE
C   -------------------------------------------------------------
C       NORM OF THE RESIDUAL. IF IT IS NOT THE CASE, SKIP UPDATING
C       ----------------------------------------------------------
C
      RNI1 = DSQRT(RNI2)
      IF (RNI1.LT.GNOISE) RETURN
C
C   SELECT BFGS OR RK1 UPDATE, DEPENDING ON CONVEXITY OF THE ELEMENT
C   ----------------------------------------------------------------
C       FUNCTION
C       --------
C
      IF (YSI.GT.0.0 .AND. SBSI.GT.0.0 .AND. IABS(ISELF).LE.1) GO TO 120
      ISELF = ISIGN(2,ISELF)
C
C   1) THE ELEMENT FUNCTION IS NOT CONVEX: APPLY RK1 UPDATE. BUILD THE
C       INNER PRODUCT OF THE RESIDUAL TIMES THE PROJECTED STEP, AND THE
C       NORM OF THESE VECTORS
C
      RSI = YSI - SBSI
      DO 70 J=1,NSUBI
        P1(J) = Y(J) - P1(J)
   70 CONTINUE
C
C   2) TEST IF THE DENOMINATOR IS BIG ENOUGH. IF THIS IS NOT THE CASE,
C       AVOID UPDATING
C
      TEMP = DABS(RSI)
      IF (TEMP.LE.RELPR .OR. TEMP.LE.(0.1*DSQRT(SNI2)*RNI1)) RETURN
C
C   3) APPLY RK1 UPDATE
C
      L = 0
      RSII = 1.0D0/RSI
      DO 80 J=1,NSUBI
        P2(J) = P1(J)*RSII
   80 CONTINUE
      DO 100 J=1,NSUBI
        DO 90 K=1,J
          L = L + 1
          B(L) = B(L) + P1(J)*P2(K)
   90   CONTINUE
  100 CONTINUE
C
C   4) UPDATE THE DIAGONAL ACCORDINGLY
C
      CALL RANGE(IELF, IUTB, P1, P2, NDIMI, NSUBI, NS)
      DO 110 J=1,NDIMI
        IVAR = INVAR(J)
        D(IVAR) = D(IVAR) + P2(J)*P2(J)/RSI
  110 CONTINUE
      RETURN
C
C   5) THE ELEMENT FUNCTION IS CONVEX: TEST FOR SCALING AT FIRST
C       ITERATION
C
  120 CONTINUE
      IF (SCAL1) GO TO 160
C
C   6) SCALING OF THE ELEMENT HESSIAN
C
      IF (SBSI.LE.RELPR .AND. YSI.LE.RELPR) RETURN
      IF (SBSI.GT.RELPR) GO TO 130
      INFO = IELF
      IFLAG = 30
      GO TO 260
  130 CONTINUE
      Q = YSI/SBSI
      DO 140 J=1,KU
        B(J) = Q*B(J)
  140 CONTINUE
      DO 150 J=1,NSUBI
        P1(J) = Q*P1(J)
  150 CONTINUE
      SBSI = YSI
      Q = Q - 1.0
C
C   7) APPLY BFGS UPDATE
C
  160 CONTINUE
      L = 0
      DYSI = 1./DSQRT(YSI)
      DSBSI = 1./DSQRT(SBSI)
      DO 170 J=1,NSUBI
        P3(J) = Y(J)*DYSI
        P2(J) = P1(J)*DSBSI
  170 CONTINUE
      DO 190 J=1,NSUBI
        DO 180 K=1,J
          L = L + 1
          B(L) = B(L) + P3(J)*P3(K) - P2(J)*P2(K)
  180   CONTINUE
  190 CONTINUE
C
C   8) UPDATE THE DIAGONAL ACCORDINGLY
C
      CALL RANGE(IELF, IUTB, P1, P2, NDIMI, NSUBI, NS)
      DO 200 J=1,NDIMI
        P1(J) = (P2(J)**2)/SBSI
  200 CONTINUE
      CALL RANGE(IELF, IUTB, Y, P2, NDIMI, NSUBI, NS)
      DO 210 J=1,NDIMI
        Y(J) = (P2(J)**2)/YSI - P1(J)
  210 CONTINUE
      NDIMIT = NDIMI
      DO 250 J=1,NDIMI
        IVAR = INVAR(J)
        IF (SCAL1) GO TO 240
        DO 220 K=1,NDIMI
          P1(K) = 0.0
  220   CONTINUE
        P1(J) = 1.0
        IF (NSUBI.EQ.NDIMI) GO TO 230
        CALL RANGE(IELF, IUB, P1, P2, NDIMIT, NSUBI, NS)
        CALL RANGE(IELF, IUTB, P2, P1, NDIMIT, NSUBI, NS)
  230   CONTINUE
        D(IVAR) = D(IVAR) + Q*P1(J)
  240   CONTINUE
        D(IVAR) = D(IVAR) + Y(J)
  250 CONTINUE
      RETURN
  260 CONTINUE
      IRTN = 1
      RETURN
      END

      SUBROUTINE VE08MD(RES,X,Y,N)
C
C
C       **********************************************
C       *                                            *
C       *    INNER PRODUCT OF X AND Y IN RES         *
C       *                                            *
C       **********************************************
C

      INTEGER N
      DOUBLE PRECISION RES, X(N), Y(N)


      RES = 0.0
      DO 10 I=1,N
         RES = RES + X(I)*Y(I)
10    CONTINUE
      RETURN
      END

      SUBROUTINE VE08ND(DX, W1, STEP, GX, W2, W3, RES, N)
C
C
C       **********************************************
C       *                                            *
C       *    FIRST INNER LOOP OF CONJUGATE GRADIENT  *
C       *                                            *
C       **********************************************
C
C
      DOUBLE PRECISION RES, STEP
C
C
      DOUBLE PRECISION DX(1), W1(1), W2(1), W3(1), GX(1)
C
C
      RES = 0.0
      DO 10 I=1,N
        DX(I) = DX(I) + STEP*W1(I)
        GX(I) = GX(I) - STEP*W2(I)
        W2(I) = GX(I)*W3(I)
        RES = RES + W2(I)*GX(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE VE08OD(R, X, Y, BETA, N)
C
C
C       ************************************************
C       *                                              *
C       *   SECOND INNER LOOP OF CONJUGATE GRADIENTS   *
C       *                                              *
C       ************************************************
C
C
      DOUBLE PRECISION BETA
C
C
      DOUBLE PRECISION R(1), X(1), Y(1)
C
C
      DO 10 I=1,N
        R(I) = X(I) + BETA*Y(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE VE08PD(H, X, Y, NSUBI)
C
C
C       *********************************************************
C       *                                                       *
C       *   THIS ROUTINE COMPUTES THE PRODUCT H*X=Y, WHERE      *
C       *     H IS AN ELEMENT HESSIAN MATRIX OF DIMENSION       *
C       *     NSUBI*NSUBI AND WHERE X AND Y AND TWO VECTORS     *
C       *     OF DIMENSION NSUBI.                               *
C       *                                                       *
C       *********************************************************
C
C
C
      DOUBLE PRECISION H(1), X(1), Y(1)
C
C
C
C   RESET THE RESULT VECTOR Y TO ZERO
C   ---------------------------------
C
      DO 10 I=2,NSUBI
        Y(I) = 0.0
   10 CONTINUE
C
C   COMPUTE THE PRODUCT
C   -------------------
C
      L = 1
      Y(1) = H(1)*X(1)
      IF (NSUBI.LT.2) RETURN
      DO 30 I=2,NSUBI
        ITEMP = I - 1
        DO 20 J=1,ITEMP
          L = L + 1
          Y(I) = Y(I) + H(L)*X(J)
          Y(J) = Y(J) + H(L)*X(I)
   20   CONTINUE
        L = L + 1
        Y(I) = Y(I) + H(L)*X(I)
   30 CONTINUE
      RETURN
      END

      SUBROUTINE VE08QD(KIT, FX, GXN, NGR, DNGR, ALPHA, ITSTEP, BOUNDS,
     * X, GX, S, B, IP1, NLP, N, NS, M, NVAR, P1, P2, RANGE)
C
C
C       ****************************************************
C       *                                                  *
C       *   PRINTING SUBROUTINE FOR PARTIALLY SEPARABLE    *
C       *               MINIMIZATION                       *
C       *                                                  *
C       ****************************************************
C
C
      DOUBLE PRECISION ALPHA, DNGR, FX, GXN
      INTEGER KIT(2), NGR(2)
      LOGICAL BOUNDS
      EXTERNAL RANGE
C
C
C       THE PRINTOUT GENERATED BY THIS ROUTINE IS GOVERNED BY THE VALUE
C       OF THE ARGUMENTS IP1 AS FOLLOWS :
C
C       IP1 DETERMINE THE ITEMS TO BE PRINTED :
C
C       IP1=0   THE ITERATION COUNT (KIT(2)), THE FUNCTION VALUE (FX),
C                THE NORM OF THE GRADIENT (GXN) AND THE NUMBER OF
C                OBJECTIVE FUNCTION SUBROUTINE CALLS (NGR(2),DNGR)
C       IP1=1   AS WITH IP1=0 + STEP SELECTION ITERATIONS (ITSTEP)
C                AND THE LINESEARCH PARAMETER (ALPHA)
C       IP1=2   AS WITH IP1=1 + THE VECTOR OF VARIABLES (X(K),K=1,N)
C       IP1=3   AS WITH IP1=2 + THE GRADIENT VECTOR (GX(K),K=1,N)
C       IP1=4   AS WITH IP1=3 + THE RECENT CHANGE IN THE VARIABLES
C                (S(K),K=1,N)
C       IP1=5   AS WITH IP1=4 + THE VALUES OF THE NONZERO ELEMENTS IN
C                THE APPROXIMATE HESSIAN MATRIX (B(K),K=1,M)
C
C
C       THE ARRAYS APPEARING IN THE ARGUMENT LIST ARE DIMENSIONED BY
      DOUBLE PRECISION X(1), GX(1), S(1), B(1), P1(1), P2(1)
      INTEGER NVAR(1)
C
C   PRINT THE REQUIRED ITEMS
C
      WRITE (NLP,99999) KIT(2), DNGR, NGR(2)
      IF (.NOT.BOUNDS) WRITE (NLP,99998) FX, GXN
      IF (BOUNDS) WRITE (NLP,99997) FX, GXN
      IF (IP1.LE.0) RETURN
      WRITE (NLP,99996) ITSTEP, ALPHA
      IF (IP1.LE.1) RETURN
      WRITE (NLP,99995)
      WRITE (NLP,99994) (X(K),K=1,N)
      IF (IP1.LE.2) RETURN
      WRITE (NLP,99993)
      WRITE (NLP,99994) (GX(K),K=1,N)
      IF (IP1.LE.3) RETURN
      IF (KIT(2).GE.0) WRITE (NLP,99992)
      IF (KIT(2).LT.0) WRITE (NLP,99991)
      WRITE (NLP,99994) (S(K),K=1,N)
      IF (IP1.LE.4) RETURN
      L = 0
        NST = NS
      DO 20 J=1,NS
        WRITE (NLP,99989) J
        JL = NVAR(J)
        NDIMI = NVAR(J+1) - JL
        IELF = J
        CALL RANGE(IELF, 1, P1, P2, NDIMI, NSUBI, NST)
        IF (NSUBI.EQ.0) GO TO 20
        DO 10 K=1,NSUBI
          LP1 = L + 1
          LPK = L + K
          WRITE (NLP,99988) (B(KK),KK=LP1,LPK)
          L = LPK
   10   CONTINUE
   20 CONTINUE
      WRITE (NLP,99990)
      RETURN
C
C   FORMATS
C
99999 FORMAT (///4X, 15H**** ITERATION , I4, 11H   ( AFTER , F9.2, 2H (,
     * I7, 17H) FUNCTION CALLS))
99998 FORMAT (//5X, 17HFUNCTION VALUE = , D23.15//5X, 14HNORM OF THE GR,
     * 9HADIENT = , D16.7)
99997 FORMAT (//5X, 17HFUNCTION VALUE = , D23.15//5X, 14HNORM OF THE PR,
     * 19HOJECTED GRADIENT = , D16.7)
99996 FORMAT (/5X, 25HSTEP STRATEGY ITERATIONS , I7, 5X, 10HLINESEARCH,
     * 11H PARAMETER , D10.3)
99995 FORMAT (/5X, 22HAPPROXIMATE SOLUTION X/)
99994 FORMAT (5X, 5D15.7)
99993 FORMAT (/5X, 34HGRADIENT AT APPROXIMATE SOLUTION X/)
99992 FORMAT (/5X, 26HLAST STEP OF THE ALGORITHM/)
99991 FORMAT (/5X, 23HORIGINAL STARTING POINT/)
99990 FORMAT (/5X, 50(1H*)//)
99989 FORMAT (/5X, 10HPROJECTED , I4, 19H-TH ELEMENT HESSIAN/)
99988 FORMAT (5X, 10D12.2)
      END

      SUBROUTINE VE08RD(X, GX, ISTATE, N, EBOUND, XUPPER, XLOWER)
C
C
C       ************************************************************
C       *                                                          *
C       *     THIS ROUTINE REDEFINES THE STATE OF THE BOUNDED      *
C       *       VARIABLES WITH RESPECT TO THEIR BOUND, ACCORDING   *
C       *       TO A STRATEGY PROPOSED BY BERTSEKAS.               *
C       *                                                          *
C       ************************************************************
C
C
      DOUBLE PRECISION DBI, EBOUND, EPSIT, UBI, WI, XUPPER, XLOWER
      EXTERNAL XUPPER, XLOWER
C
C
C
      DOUBLE PRECISION X(1), GX(1)
      INTEGER ISTATE(1)
C
C
C***********************************************************************
C
C         DETERMINE THE TOLERANCE ASSOCIATED WITH THE PRESENT ITERATE
C
C***********************************************************************
C
C
C   LOOP ON THE VARIABLES
C   ---------------------
C
      EPSIT = 0.0
      DO 30 I=1,N
        IF (ISTATE(I).LE.0) GO TO 30
        IVAR = I
C
C   BUILD THE GRADIENT STEP FROM THE PRESENT ITERATE
C   ------------------------------------------------
C
        WI = X(I) - GX(I)
C
C   CHECK GRADIENT STEP W.R.T. THE UPPER BOUND
C   ------------------------------------------
C
        UBI = XUPPER(IVAR)
        IF (WI.LE.UBI) GO TO 10
        WI = UBI
        GO TO 20
C
C   CHECK GRADIENT STEP W.R.T. THE LOWER BOUND
C   ------------------------------------------
C
   10   CONTINUE
        DBI = XLOWER(IVAR)
        IF (WI.LT.DBI) WI = DBI
C
C   ACCUMULATE THE SQUARE OF THE TOLERANCE
C   --------------------------------------
C
   20   CONTINUE
        EPSIT = EPSIT + (X(I)-WI)**2
C
C   END OF THE LOOP ON THE VARIABLES: DEFINE THE FINAL TOLERANCE
C   ------------------------------------------------------------
C
   30 CONTINUE
      EPSIT = DSQRT(EPSIT)
      EPSIT = DMIN1(EPSIT,EBOUND)
C
C
C***********************************************************************
C
C               REDEFINE THE STATE OF EACH BOUNDED VARIABLE
C
C***********************************************************************
C
C
C   LOOP ON THE BOUNDED VARIABLES
C   -----------------------------
C
      DO 60 I=1,N
        IF (ISTATE(I).LE.0) GO TO 60
        IVAR = I
        ISTATE(I) = 3
C
C   CHECK THE I-TH VARIABLE W.R.T. ITS UPPER BOUND
C   ----------------------------------------------
C
        UBI = XUPPER(IVAR)
        WI = UBI - X(I)
        IF (WI.GT.EPSIT) GO TO 40
        IF (GX(I).LT.0.0) GO TO 50
C
C   CHECK THE I-TH VARIABLE W.R.T. ITS LOWER BOUND
C   ----------------------------------------------
C
   40   CONTINUE
        DBI = XLOWER(IVAR)
        WI = X(I) - DBI
        IF (WI.GT.EPSIT) GO TO 60
        IF (GX(I).LE.0.0) GO TO 60
C
C   THE I-TH VARIABLE SHOULD BE IN THE DANGEROUS SET. SET THE VALUE
C   ---------------------------------------------------------------
C         OF ISTATE ACCORDINGLY
C         ---------------------
C
   50   CONTINUE
        IF (WI.LE.0.0) ISTATE(I) = 1
        IF (WI.GT.0.0) ISTATE(I) = 2
C
C   END OF THE LOOP ON THE BOUNDED VARIABLES
C   ----------------------------------------
C
   60 CONTINUE
      RETURN
      END

      SUBROUTINE VE08SD(EPSIL, NIT, NGR, DNGR, ITMAX, NFMAX, GXN,
     * NEGCUR, DIFEST, X, FX, GX, DX, DF, N, INFO, IFLAG)
C
C
C       *********************************************************
C       *                                                       *
C       *   THIS ROUTINE IMPLEMENTS THE CLASSICAL STOPPING      *
C       *     CRITERION FOR MINIMIZATION ROUTINES.              *
C       *                                                       *
C       *   NORM USED: ORDINARY 2-NORM.                         *
C       *                                                       *
C       *********************************************************
C
C
      DOUBLE PRECISION DF, DNGR, DNGRMX, DX, EPSIL, EPS2, EPS3
      DOUBLE PRECISION FX, GXN, EPS
      LOGICAL NEGCUR, DIFEST
C
      DOUBLE PRECISION X(1), GX(1)
      INTEGER NGR(2), NIT(2)
C
C
C
C   INITIALIZE THE MAIN ACCURACY CONSTANTS
C   --------------------------------------
C
      EPS = EPSIL
      IF (DIFEST) EPS = DMAX1(EPSIL,1.0D-4)
      EPS2 = EPS*EPS
      EPS3 = 0.001*EPS2
C
C   SET RETURN FLAG TO DISABLED
C   ---------------------------
C
      IFLAG = 0
C
C   TEST FOR SUFFICIENT ACCURACY
C   ----------------------------
C
      IF (GXN.GT.EPS .OR. NEGCUR) GO TO 10
      IFLAG = 1
      RETURN
C
C   CHECK IF THE MAXIMUM NUMBER OF FUNCTION CALLS HAS BEEN EXCEEDED
C   ---------------------------------------------------------------
C
   10 CONTINUE
      DNGRMX = FLOAT(NFMAX)
      IF (DNGR.LT.DNGRMX) GO TO 20
      IFLAG = 2
      RETURN
C
C   CHECK IF PROGRESS OF THE ALGORITHM IS SUFFICIENT
C   ------------------------------------------------
C
   20 CONTINUE
      IF (DF.GT.EPS3 .OR. DX.GT.EPS3) RETURN
      IFLAG = 3
      RETURN
      END

      SUBROUTINE VE08TD(A, X, FX, GXS, SNORM, S, N)
C
C
C       ***************************************************************
C       *                                                             *
C       *   THIS SUBROUTINE ALLOWS THE USER TO VERIFY THE PLAUSIBILTY *
C       *     OF THE VALUE TO BE ATTRIBUTED TO THE LINESEARCH         *
C       *     PARAMETER. IF THE VALUE PROPOSED IN A IS NOT SUITABLE,  *
C       *     THE USER SHOULD RETURN (IN A) A MORE APPROPRIATE ONE.   *
C       *                                                             *
C       *   THE LINESEARCH IS STARTING FROM THE POINT X IN DIRECTION  *
C       *     S (OF NORM SNORM). THE INITIAL FUNCTION AND DIRECTIONAL *
C       *     DERIVATIVE VALUES ARE GIVEN IN FX AND GXS. THE NUMBER   *
C       *     OF VARIABLES IS N.                                      *
C       *                                                             *
C       ***************************************************************
C
      DOUBLE PRECISION X(1), S(1), A, FX, GXS, SNORM
C
C
C
      RETURN
      END
